"""LCM type definitions
This file automatically generated by lcm.
DO NOT MODIFY BY HAND!!!!
"""

try:
    import cStringIO.StringIO as BytesIO
except ImportError:
    from io import BytesIO
import struct

import exlcm.altitude_t

import exlcm.latitude_t

import exlcm.longitude_t

class gps(object):
    __slots__ = ["timestamp", "latitude", "longitude", "altitude", "utm_x", "utm_y"]

    def __init__(self):
        self.timestamp = 0.0
        self.latitude = exlcm.latitude_t()
        self.longitude = exlcm.longitude_t()
        self.altitude = exlcm.altitude_t()
        self.utm_x = 0.0
        self.utm_y = 0.0

    def encode(self):
        buf = BytesIO()
        buf.write(gps._get_packed_fingerprint())
        self._encode_one(buf)
        return buf.getvalue()

    def _encode_one(self, buf):
        buf.write(struct.pack(">d", self.timestamp))
        assert self.latitude._get_packed_fingerprint() == exlcm.latitude_t._get_packed_fingerprint()
        self.latitude._encode_one(buf)
        assert self.longitude._get_packed_fingerprint() == exlcm.longitude_t._get_packed_fingerprint()
        self.longitude._encode_one(buf)
        assert self.altitude._get_packed_fingerprint() == exlcm.altitude_t._get_packed_fingerprint()
        self.altitude._encode_one(buf)
        buf.write(struct.pack(">dd", self.utm_x, self.utm_y))

    def decode(data):
        if hasattr(data, 'read'):
            buf = data
        else:
            buf = BytesIO(data)
        if buf.read(8) != gps._get_packed_fingerprint():
            raise ValueError("Decode error")
        return gps._decode_one(buf)
    decode = staticmethod(decode)

    def _decode_one(buf):
        self = gps()
        self.timestamp = struct.unpack(">d", buf.read(8))[0]
        self.latitude = exlcm.latitude_t._decode_one(buf)
        self.longitude = exlcm.longitude_t._decode_one(buf)
        self.altitude = exlcm.altitude_t._decode_one(buf)
        self.utm_x, self.utm_y = struct.unpack(">dd", buf.read(16))
        return self
    _decode_one = staticmethod(_decode_one)

    _hash = None
    def _get_hash_recursive(parents):
        if gps in parents: return 0
        newparents = parents + [gps]
        tmphash = (0x6eebbf0c7fafe945+ exlcm.latitude_t._get_hash_recursive(newparents)+ exlcm.longitude_t._get_hash_recursive(newparents)+ exlcm.altitude_t._get_hash_recursive(newparents)) & 0xffffffffffffffff
        tmphash  = (((tmphash<<1)&0xffffffffffffffff)  + (tmphash>>63)) & 0xffffffffffffffff
        return tmphash
    _get_hash_recursive = staticmethod(_get_hash_recursive)
    _packed_fingerprint = None

    def _get_packed_fingerprint():
        if gps._packed_fingerprint is None:
            gps._packed_fingerprint = struct.pack(">Q", gps._get_hash_recursive([]))
        return gps._packed_fingerprint
    _get_packed_fingerprint = staticmethod(_get_packed_fingerprint)

